.386
.model flat,stdcall
option casemap:none

include RTFPrint.Inc

.code

start:

	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	invoke	GetCommandLine
	mov		CommandLine,eax
	invoke	InitCommonControls
	mov		iccex.dwSize,sizeof INITCOMMONCONTROLSEX    ;prepare common control structure
	mov		iccex.dwICC,ICC_DATE_CLASSES
	invoke	InitCommonControlsEx,addr iccex
	invoke	LoadLibrary,addr RichEditDLL
	mov		hRichEdDLL,eax
	invoke	LoadLibrary, offset szWinSpoolDRV 
	mov		hSpoolLib, eax
	or		eax, eax 
	jnz		@F 
	invoke	LoadLibrary, offset szWinSpoolDLL 
	mov		hSpoolLib, eax
@@:
	invoke	GetProcAddress, hSpoolLib, offset szOpenPrinterA 
	mov		pOpenPrinterA, eax
	invoke	GetProcAddress, hSpoolLib, offset szClosePrinter 
	mov		pClosePrinter, eax
	invoke	GetProcAddress, hSpoolLib, offset szDocumentProperties 
	mov		pDocumentProperties, eax
	invoke	WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	push	eax
	invoke	FreeLibrary,hRichEdDLL
	invoke	FreeLibrary, hSpoolLib
	pop		eax
	invoke	ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,NULL
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		hIcon,eax
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DLG,NULL,addr WndProc,NULL
	mov		hWnd,eax
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .break .if !eax
		invoke IsDialogMessage,hFind,addr msg
		.if !eax
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		.endif
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

StreamInProc proc hFile:DWORD,pBuffer:DWORD,NumBytes:DWORD,pBytesRead:DWORD

	invoke ReadFile,hFile,pBuffer,NumBytes,pBytesRead,0
	xor		eax,1
	ret

StreamInProc endp

StreamOutProc proc hFile:DWORD,pBuffer:DWORD,NumBytes:DWORD,pBytesWritten:DWORD

	invoke WriteFile,hFile,pBuffer,NumBytes,pBytesWritten,0
	xor		eax,1
	ret

StreamOutProc endp

SetWinCaption proc
	LOCAL	buffer[sizeof AppName+3+MAX_PATH]:BYTE
	LOCAL	buffer1[4]:BYTE

	;Add filename to windows caption
	invoke lstrcpy,addr buffer,addr AppName
	mov		eax,' - '
	mov		dword ptr buffer1,eax
	invoke lstrcat,addr buffer,addr buffer1
;	invoke lstrcat,addr buffer,addr FileName
	invoke lstrcat,addr buffer,addr Masm32RTF
	invoke SetWindowText,hWnd,addr buffer
	ret

SetWinCaption endp

SaveFile proc lpFileName:DWORD
	LOCAL	hFile:DWORD
	LOCAL	editstream:EDITSTREAM

	invoke CreateFile,lpFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	.if eax!=INVALID_HANDLE_VALUE
		mov		hFile,eax
		;stream the text to the file
		mov		editstream.dwCookie,eax
		mov		editstream.pfnCallback,offset StreamOutProc
;		invoke SendMessage,hREd,EM_STREAMOUT,SF_TEXT,addr editstream
		invoke SendMessage,hREd,EM_STREAMOUT,SF_RTF,addr editstream
		invoke CloseHandle,hFile
		;Set the modify state to false
		invoke SendMessage,hREd,EM_SETMODIFY,FALSE,0
   		mov		eax,FALSE
	.else
		invoke MessageBox,hWnd,addr SaveFileFail,addr AppName,MB_OK
		mov		eax,TRUE
	.endif
	ret

SaveFile endp

SaveEditAs proc
	LOCAL	ofn:OPENFILENAME
	LOCAL	buffer[MAX_PATH]:BYTE

	;Zero out the ofn struct
    invoke RtlZeroMemory,addr ofn,sizeof ofn
	;Setup the ofn struct
	mov		ofn.lStructSize,sizeof ofn
	push	hWnd
	pop		ofn.hwndOwner
	push	hInstance
	pop		ofn.hInstance
	mov		ofn.lpstrFilter,NULL
	mov		buffer[0],0
	lea		eax,buffer
	mov		ofn.lpstrFile,eax
	mov		ofn.nMaxFile,sizeof buffer
	mov		ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_OVERWRITEPROMPT
    mov		ofn.lpstrDefExt,NULL
    ;Show save as dialog
	invoke GetSaveFileName,addr ofn
	.if eax
		invoke SaveFile,addr buffer
		.if !eax
			;The file was saved
			invoke lstrcpy,addr FileName,addr buffer
			invoke SetWinCaption
			mov		eax,FALSE
		.endif
	.else
		mov		eax,TRUE
	.endif
	ret

SaveEditAs endp

SaveEdit proc

	;Check if filrname is (Untitled)
	invoke lstrcmp,addr FileName,addr NewFile
	.if eax
		invoke SaveFile,addr FileName
	.else
		invoke SaveEditAs
	.endif
	ret

SaveEdit endp

WantToSave proc
	LOCAL	buffer[512]:BYTE
	LOCAL	buffer1[2]:BYTE

	invoke SendMessage,hREd,EM_GETMODIFY,0,0
	.if eax
		invoke lstrcpy,addr buffer,addr WannaSave
		invoke lstrcat,addr buffer,addr FileName
		mov		ax,'?'
		mov		word ptr buffer1,ax
		invoke lstrcat,addr buffer,addr buffer1
		invoke MessageBox,hWnd,addr buffer,addr AppName,MB_YESNOCANCEL or MB_ICONQUESTION
		.if eax==IDYES
			invoke SaveEdit
	    .elseif eax==IDNO
		    mov		eax,FALSE
	    .else
		    mov		eax,TRUE
		.endif
	.endif
	ret

WantToSave endp

OpenEdit proc
	LOCAL	ofn:OPENFILENAME
    LOCAL   hFile:DWORD
	LOCAL	editstream:EDITSTREAM
	LOCAL	buffer[MAX_PATH]:BYTE
	LOCAL	chrg:CHARRANGE

	;Zero out the ofn struct
	invoke RtlZeroMemory,addr ofn,sizeof ofn
	;Setup the ofn struct
	mov		ofn.lStructSize,sizeof ofn
	push	hWnd
	pop		ofn.hwndOwner
	push	hInstance
	pop		ofn.hInstance
	mov		ofn.lpstrFilter,NULL
	mov		buffer[0],0
	lea		eax,buffer
	mov		ofn.lpstrFile,eax
	mov		ofn.nMaxFile,sizeof buffer
	mov		ofn.lpstrDefExt,NULL
	mov		ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST
	;Show the Open dialog
	invoke GetOpenFileName,addr ofn
	.if eax
		;Open the file
		invoke CreateFile,addr buffer,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
		.if eax!=INVALID_HANDLE_VALUE
			mov		hFile,eax
			;Copy buffer to FileName
			invoke lstrcpy,addr FileName,addr buffer
			;stream the text into the richedit control
			push	hFile
			pop		editstream.dwCookie
			mov		editstream.pfnCallback,offset StreamInProc
;			invoke SendMessage,hREd,EM_STREAMIN,SF_TEXT,addr editstream
			invoke SendMessage,hREd,EM_STREAMIN,SF_RTF,addr editstream
			invoke CloseHandle,hFile
			invoke SendMessage,hREd,EM_SETMODIFY,FALSE,0
			mov		chrg.cpMin,0
			mov		chrg.cpMax,0
			invoke SendMessage,hREd,EM_EXSETSEL,0,addr chrg
			invoke SetWinCaption
			mov		eax,FALSE
		.else
			invoke MessageBox,hWnd,addr OpenFileFail,addr AppName,MB_OK
			mov		eax,TRUE
		.endif
	.endif
	ret

OpenEdit endp

FindDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hCtl:DWORD

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		mov		eax,hWin
		mov		hFind,eax
		.if !lParam
			;Disable replace
			invoke GetDlgItem,hWin,IDC_REPLACETEXT
			mov     hCtl,eax
			invoke GetWindowLong,hCtl,GWL_STYLE
			xor     eax,WS_VISIBLE
			invoke SetWindowLong,hCtl,GWL_STYLE,eax
			invoke GetDlgItem,hWin,IDC_REPLACESTATIC
			mov     hCtl,eax
			invoke GetWindowLong,hCtl,GWL_STYLE
			xor     eax,WS_VISIBLE
			invoke SetWindowLong,hCtl,GWL_STYLE,eax
			invoke GetDlgItem,hWin,IDC_BTN_REPLACEALL
			invoke EnableWindow,eax,FALSE
		.else
			invoke SetWindowText,hWin, addr Replace
		.endif
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDOK

			.elseif eax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		mov		hFind,0
		invoke EndDialog,hWin,NULL
	.else
		mov eax,FALSE
		ret
	.endif
	mov  eax,TRUE
	ret

FindDlgProc endp

DoToolBar proc hInst:DWORD,hToolBar:HWND
	LOCAL	tbab:TBADDBITMAP

	;Set toolbar struct size
	invoke SendMessage,hToolBar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
	;Set toolbar bitmap
	push	hInst
	pop		tbab.hInst
	mov		tbab.nID,IDB_TBRBMP
	invoke SendMessage,hToolBar,TB_ADDBITMAP,15,addr tbab
	;Set toolbar buttons
	invoke SendMessage,hToolBar,TB_ADDBUTTONS,ntbrbtns,addr tbrbtns
	mov		eax,hToolBar
	ret

DoToolBar endp

SetFormat proc hWin:DWORD
    LOCAL	chrg1:CHARRANGE
    LOCAL	chrg2:CHARRANGE
	LOCAL	pf:PARAFORMAT2
	LOCAL	cf:CHARFORMAT
	LOCAL	tp:DWORD
	LOCAL	buffer[16]:BYTE
	LOCAL	pt:POINT
	LOCAL	hDC:HDC

	;Save modify state
	invoke SendMessage,hWin,EM_GETMODIFY,0,0
	push	eax
	;Save selection
	invoke SendMessage,hWin,EM_EXGETSEL,0,addr chrg1
	invoke SendMessage,hWin,EM_HIDESELECTION,TRUE,0
	;Select all text
	mov		chrg2.cpMin,0
	mov		chrg2.cpMax,-1
	invoke SendMessage,hWin,EM_EXSETSEL,0,addr chrg2
	;Set font charset
	mov		cf.cbSize,sizeof cf
	mov		cf.dwMask,CFM_CHARSET or CFM_FACE or CFM_SIZE or CFM_COLOR
	mov		al,lfnt.lfCharSet
	mov		cf.bCharSet,al
	mov		al,lfnt.lfPitchAndFamily
	mov		cf.bPitchAndFamily,al
	invoke lstrcpyn,addr cf.szFaceName,addr lfnt.lfFaceName,LF_FACESIZE
	mov		eax,lfnt.lfHeight
	neg		eax
	mov		ecx,15
	mul		ecx
	mov		cf.yHeight,eax
	mov		eax,rgb
	mov		cf.crTextColor,eax
	invoke SendMessage,hWin,EM_SETCHARFORMAT,SCF_SELECTION,addr cf
	;Get tab width
	invoke GetDC,hWin
	mov		hDC,eax
	invoke SelectObject,hDC,hFont
	push	eax
	mov		eax,'WWWW'
	mov		dword ptr buffer,eax
	invoke GetTextExtentPoint32,hDC,addr buffer,4,addr pt
	pop		eax
	invoke SelectObject,hDC,eax
	invoke ReleaseDC,hWin,hDC
	mov		eax,pt.x
	mov		ecx,TabSize
	mul		ecx
	mov		ecx,15
	mul		ecx
	shr		eax,2
	mov		tp,eax
	;Set tab stops
	mov		pf.cbSize,sizeof pf
	mov		pf.dwMask,PFM_TABSTOPS
	mov		pf.cTabCount,MAX_TAB_STOPS
	xor		eax,eax
	xor		edx,edx
	mov		ecx,MAX_TAB_STOPS
  @@:
	add		eax,tp
	mov		dword ptr pf.rgxTabs[edx],eax
	add		edx,4
	loop	@b
	invoke SendMessage,hWin,EM_SETPARAFORMAT,0,addr pf
	;Restore modify state
	pop		eax
	invoke SendMessage,hWin,EM_SETMODIFY,eax,0
	;Restore selection
	invoke SendMessage,hWin,EM_EXSETSEL,0,addr chrg1
	invoke SendMessage,hWin,EM_HIDESELECTION,FALSE,0
	ret

SetFormat endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	pt:POINT
	LOCAL	rect:RECT
	LOCAL	ht:DWORD
	LOCAL	hCtl:HWND
	LOCAL	chrg:CHARRANGE
	LOCAL	cf:CHOOSEFONT

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		mov		fView,3
		mov		TabSize,4
		;Set the toolbar buttons
		invoke GetDlgItem,hWin,IDC_TBR
		invoke DoToolBar,hInstance,eax
		;Set FileName to NewFile
		invoke lstrcpy,addr FileName,addr NewFile
		invoke SetWinCaption
		;Get handle of RichEdit window and give it focus
		invoke GetDlgItem,hWin,IDC_RED
		mov		hREd,eax
;		invoke SendMessage,hREd,EM_SETTEXTMODE,0,TM_PLAINTEXT
		invoke SendMessage,hREd,EM_SETTEXTMODE,0,TM_RICHTEXT
		;Set event mask
		invoke SendMessage,hREd,EM_SETEVENTMASK,0,ENM_SELCHANGE
		;Set the text limit. The default is 64K
		invoke SendMessage,hREd,EM_LIMITTEXT,-1,0
		;Create font
		invoke lstrcpy,addr lfnt.lfFaceName,offset szFont
		mov		lfnt.lfHeight,-12
		mov		lfnt.lfWeight,400
		invoke CreateFontIndirect,addr lfnt
		mov     hFont,eax
		;Set font & format
;		invoke SetFormat,hREd
		;Init RichEdit
		invoke SendMessage,hREd,EM_SETMODIFY,FALSE,0
		invoke SendMessage,hREd,EM_EMPTYUNDOBUFFER,0,0
		invoke SetFocus,hREd
;Added by farrier
		mov		landscape, 0
		mov		NumOfCopies, 1
		call	CreateMasm32RTF
		call	ChangeBP		;change \page to *page to simulate breaks
		call	DisplayRTFFile
		call	GetPrinterInfo
		call	GetPageInfo
		call	FormatScreenLikePrinter
		call	PrintFile
		call	UnChangeBP		;change *page back to \page
	.elseif eax==WM_COMMAND
		;Menu and toolbar has the same ID's
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_NEW
			invoke WantToSave
			.if !eax
				invoke SetWindowText,hREd,addr szNULL
				invoke lstrcpy,addr FileName,addr NewFile
				invoke SetWinCaption
			.endif
			invoke SetFocus,hREd
		.elseif eax==IDM_FILE_OPEN
			invoke WantToSave
			.if !eax
				invoke OpenEdit
			.endif
			invoke SetFocus,hREd
		.elseif eax==IDM_FILE_SAVE
			invoke SaveEdit
			invoke SetFocus,hREd
		.elseif eax==IDM_FILE_SAVEAS
			invoke SaveEditAs
			invoke SetFocus,hREd
		.elseif eax==IDM_FILE_PRINT
		.elseif eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_EDIT_UNDO
			invoke SendMessage,hREd,EM_UNDO,0,0
		.elseif eax==IDM_EDIT_REDO
			invoke SendMessage,hREd,EM_REDO,0,0
		.elseif eax==IDM_EDIT_DELETE
			invoke SendMessage,hREd,EM_REPLACESEL,TRUE,0
		.elseif eax==IDM_EDIT_CUT
			invoke SendMessage,hREd,WM_CUT,0,0
		.elseif eax==IDM_EDIT_COPY
			invoke SendMessage,hREd,WM_COPY,0,0
		.elseif eax==IDM_EDIT_PASTE
			invoke SendMessage,hREd,WM_PASTE,0,0
		.elseif eax==IDM_EDIT_SELECTALL
			mov		chrg.cpMin,0
			mov		chrg.cpMax,-1
			invoke SendMessage,hREd,EM_EXSETSEL,0,addr chrg
		.elseif eax==IDM_EDIT_FIND
			.if hFind==0
				invoke CreateDialogParam,hInstance,IDD_FINDDLG,hWin,addr FindDlgProc,FALSE
			.else
				invoke SetFocus,hFind
			.endif
		.elseif eax==IDM_EDIT_REPLACE
			.if hFind==0
				invoke CreateDialogParam,hInstance,IDD_FINDDLG,hWin,addr FindDlgProc,TRUE
			.else
				invoke SetFocus,hFind
			.endif
		.elseif eax==IDM_VIEW_TOOLBAR
			invoke GetDlgItem,hWin,IDC_TBR
			mov		hCtl,eax
			xor		fView,1
			mov		eax,fView
			and		eax,1
			.if eax
				invoke ShowWindow,hCtl,SW_SHOWNA
			.else
				invoke ShowWindow,hCtl,SW_HIDE
			.endif
			invoke SendMessage,hWin,WM_SIZE,0,0
		.elseif eax==IDM_VIEW_STATUSBAR
			invoke GetDlgItem,hWin,IDC_SBR
			mov		hCtl,eax
			xor		fView,2
			mov		eax,fView
			and		eax,2
			.if eax
				invoke ShowWindow,hCtl,SW_SHOWNA
			.else
				invoke ShowWindow,hCtl,SW_HIDE
			.endif
			invoke SendMessage,hWin,WM_SIZE,0,0
		.elseif eax==IDM_OPTION_FONT
			invoke RtlZeroMemory,addr cf,sizeof cf
			mov		cf.lStructSize,sizeof cf
			mov		eax,hWin
			mov		cf.hwndOwner,eax
			mov		cf.lpLogFont,offset lfnt
			mov		cf.Flags,CF_SCREENFONTS or CF_EFFECTS or CF_INITTOLOGFONTSTRUCT
			mov		eax,rgb
			mov		cf.rgbColors,eax
			invoke ChooseFont,addr cf
			.if eax
				invoke DeleteObject,hFont
				invoke CreateFontIndirect,addr lfnt
				mov     hFont,eax
				mov		eax,cf.rgbColors
				mov		rgb,eax
				invoke SetFormat,hREd
			.endif
			invoke SetFocus,hREd
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,hIcon
			invoke SetFocus,hREd
		.endif
	.elseif eax==WM_NOTIFY
		.if wParam==IDC_RED
			;Auto horizontal scroll text into view
			invoke GetCaretPos,addr pt
			invoke GetClientRect,hREd,addr rect
			mov		eax,rect.right
			sub		eax,pt.x
			.if eax<20
				;Caret near right edge
				invoke SendMessage,hREd,EM_GETSCROLLPOS,0,addr pt
				add		pt.x,70
				invoke SendMessage,hREd,EM_SETSCROLLPOS,0,addr pt
			.endif
		.endif
	.elseif eax==WM_SIZE
		mov		eax,fView
		and		eax,1
		.if eax
			;Resize toolbar
			invoke GetDlgItem,hWin,IDC_TBR
			mov		hCtl,eax
			invoke MoveWindow,hCtl,0,0,0,0,TRUE
			;Get height of toolbar
			invoke GetWindowRect,hCtl,addr rect
			mov		eax,rect.bottom
			sub		eax,rect.top
		.endif
		push	eax
		mov		eax,fView
		and		eax,2
		.if eax
			;Resize statusbar
			invoke GetDlgItem,hWin,IDC_SBR
			mov		hCtl,eax
			invoke MoveWindow,hCtl,0,0,0,0,TRUE
			;Get height of statusbar
			invoke GetWindowRect,hCtl,addr rect
			mov		eax,rect.bottom
			sub		eax,rect.top
		.endif
		push	eax
		;Get size of windows client area
		invoke GetClientRect,hWin,addr rect
		;Subtract height of statusbar from bottom
		pop		eax
		sub		rect.bottom,eax
		;Add height of toolbar to top
		pop		eax
		add		rect.top,eax
		;Get new height of RichEdit window
		mov		eax,rect.bottom
		sub		eax,rect.top
		mov		ht,eax
		;Resize RichEdit window
		invoke MoveWindow,hREd,0,rect.top,rect.right,ht,TRUE
	.elseif eax==WM_CLOSE 
		invoke WantToSave
		.if !eax
			invoke DestroyWindow,hWin
		.endif
	.elseif eax==WM_DESTROY
		invoke DeleteObject,hFont
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

CreateMasm32RTF	proc
LOCAL	file_hand:HANDLE
	invoke	CreateFile, addr Masm32RTF, GENERIC_READ or GENERIC_WRITE, \
			NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	mov		file_hand, eax
	invoke   WriteFile, file_hand, addr rtf1, sizeof rtf1, addr nobw, NULL
         ;Writes opening header for RTF file
	invoke   WriteFile, file_hand, addr rtf2, sizeof rtf2, ADDR nobw, NULL
         ;Writes second header line
	invoke   WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
         ;rtf6 is a new line / new paragraph command
	invoke   WriteFile, file_hand, addr rtf_tab, sizeof rtf_tab, ADDR nobw, NULL
         ;rtf_tab sets the tab stops for following text
	invoke	WriteFile, file_hand, addr win32asmpro, sizeof win32asmpro, addr nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr center_it, sizeof center_it, addr nobw, NULL
	invoke	WriteFile, file_hand, addr centered, sizeof centered, addr nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr left_it, sizeof left_it, addr nobw, NULL
	invoke	WriteFile, file_hand, addr lefters, sizeof lefters, addr nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr right_it, sizeof right_it, addr nobw, NULL
	invoke	WriteFile, file_hand, addr righters, sizeof righters, addr nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr justify_it, sizeof justify_it, addr nobw, NULL
	invoke	WriteFile, file_hand, addr bold_on, sizeof bold_on, addr nobw, NULL
	invoke	WriteFile, file_hand, addr bolders, sizeof bolders, addr nobw, NULL
	invoke	WriteFile, file_hand, addr bold_off, sizeof bold_off, addr nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr italic_it, sizeof italic_it, addr nobw, NULL
	invoke	WriteFile, file_hand, addr italics, sizeof italics, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr plain_it, sizeof plain_it, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr aussies, sizeof aussies, addr nobw, NULL
	invoke	WriteFile, file_hand, addr rtf6, sizeof rtf6, ADDR nobw, NULL
	invoke	WriteFile, file_hand, addr page_break, sizeof page_break, addr nobw, NULL
	invoke	WriteFile, file_hand, addr SBOnPage2, sizeof SBOnPage2, addr nobw, NULL
	invoke	WriteFile, file_hand, addr doc_end	, sizeof doc_end	, addr nobw, NULL
	invoke	CloseHandle, file_hand
	ret

CreateMasm32RTF endp

ChangeBP	PROC uses ebx edi esi
LOCAL	hFile, rtf_length, tempH, tempP, NumRtfBytes:DWORD
	invoke	CreateFile, addr Masm32RTF, \
			GENERIC_READ + GENERIC_WRITE, FILE_SHARE_READ, NULL,\
			OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL
	mov		hFile, eax
	invoke	GetFileSize, hFile, NULL
	mov		rtf_length, eax
	invoke	GlobalAlloc, GMEM_MOVEABLE, eax
	mov		tempH, eax
	invoke	GlobalLock, eax
	mov		tempP, eax
	invoke	ReadFile, hFile, tempP, rtf_length, addr NumRtfBytes, 0
	mov		ecx, NumRtfBytes
	mov		edi, tempP
	mov		esi, 0
	mov		ebx, 0
	mov		eax, 'gap\'				;search for \pag
FindBS:
	cmp		dword ptr [edi], eax
	je		got_pb
check_a:
	inc		edi
	inc		esi
	dec		ecx
	je		got_pb
	jmp		FindBS
got_pb:
	.if( ecx )						;not done processing for page breaks
		mov	pbPointers[ebx], esi
		mov	byte ptr [edi], '*'		;replace \page with *page
		add	ebx, 4
		add	edi, 5
		add esi, 5
		sub	ecx, 5
		je	done_pb
		jmp	FindBS
	.endif
done_pb:
	invoke	SetFilePointer, hFile, 0, 0, FILE_BEGIN
	invoke	WriteFile, hFile, tempP, NumRtfBytes, addr NumRtfBytes, 0
	invoke	CloseHandle, hFile
	invoke	GlobalUnlock, tempP
	invoke	GlobalFree, tempH

	ret

ChangeBP endp

DisplayRTFFile	PROC
LOCAL	hRTFf:HANDLE
LOCAL	editstream:EDITSTREAM
	invoke	CreateFile, addr Masm32RTF, \
			GENERIC_READ, FILE_SHARE_READ, NULL,\
			OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL
	mov		hRTFf, eax
	mov		editstream.dwCookie, eax
	mov		editstream.pfnCallback, offset StreamInProc
	invoke	SendMessage, hREd, EM_STREAMIN, SF_RTF, addr editstream
	invoke	SendMessage, hREd, EM_SETMODIFY, FALSE, 0
	invoke	CloseHandle, hRTFf

	ret
DisplayRTFFile	ENDP

GetPrinterInfo	PROC uses esi
LOCAL	YorN:DWORD
	mov		YorN, 0
;Get Default printer name
	invoke	GetProfileString, CTEXT("windows"), CTEXT("Device"), CTEXT(" "), \
			addr pPrintInfo, sizeof pPrintInfo
	lea		esi, pPrintInfo
	dec		esi
check_com:
	inc		esi
	cmp		byte ptr [esi], ','
	jnz		check_com
	mov		byte ptr [esi], 0		
	inc		esi
	mov		pPrintDriver, esi
	dec		esi
get_driver:
	inc		esi
	cmp		byte ptr [esi], ','
	jnz		get_driver
	mov		byte ptr [esi], 0
;This returns a string composed of the printer name ',' printer driver ',' printer port

;	invoke	OpenPrinter, addr pPrintInfo, hPrinter, NULL
	push	NULL
	push	offset hPrinter
	push	offset pPrintInfo
	call	pOpenPrinterA

;	invoke	DocumentProperties, hREd, hPrinter, addr pPrintInfo, NULL, NULL, NULL
	push	NULL
	push	NULL
	push	NULL
	push	offset pPrintInfo
	push	hPrinter
	push	hREd
	call	pDocumentProperties
;Returns sizeof DEVMODE structure for default printer
	invoke	GlobalAlloc, GMEM_MOVEABLE, eax
;Allocate moveable memory for DEVMODE
	mov		hDevmodeOut, eax
	invoke	GlobalLock, eax
	mov		pDevmodeOut, eax     ;pointer to DEVMODE struct
;	invoke	DocumentProperties, hREd, hPrinter, addr pPrintInfo, \
;			pDevmodeOut, NULL, DM_OUT_BUFFER
	push	DM_OUT_BUFFER
	push	NULL
	push	pDevmodeOut
	push	offset pPrintInfo
	push	hPrinter
	push	hREd
	call	pDocumentProperties
;get default printer settings
	mov		edx, pDevmodeOut
	.if( landscape )
		or	[edx].DEVMODE.dmFields, DM_ORIENTATION
;let printer know we want to set orientation
		mov	[edx].DEVMODE.dmOrientation, DMORIENT_LANDSCAPE  ;set landscape mode
		mov		YorN, 1
	.endif
	.if( NumOfCopies > 1 )
		or	[edx].DEVMODE.dmFields, DM_COPIES
;let printer know we want to set # of copies
		mov	[edx].DEVMODE.dmCopies, 2
		or	[edx].DEVMODE.dmFields, DM_COLLATE
;let printer know we want to set collate function
		mov	[edx].DEVMODE.dmCollate, DMCOLLATE_TRUE
		mov		YorN, 1
	.endif
 	.if( YorN )
;		invoke	DocumentProperties, hREd, hPrinter, addr pPrintInfo, \
;				pDevmodeOut, pDevmodeOut, DM_OUT_BUFFER or DM_IN_BUFFER
		push	DM_OUT_BUFFER or DM_IN_BUFFER
		push	pDevmodeOut
		push	pDevmodeOut
		push	offset pPrintInfo
		push	hPrinter
		push	hREd
		call	pDocumentProperties
	.endif			;set landscape +/or multiple copies
	invoke	CreateDC, pPrintDriver, offset pPrintInfo, NULL, pDevmodeOut
	mov		dcPrint, eax
;	invoke	ClosePrinter, hPrinter
	push	hPrinter
	call	pClosePrinter
	invoke	GlobalUnlock, pDevmodeOut
	invoke	GlobalFree, hDevmodeOut

	ret
GetPrinterInfo endp

GetPageInfo	PROC
;To modify RichEdit Window to match Printer we need:
;	LineWidth = LeftMargin - RightMargin
;	LeftMargin = LeftMarginWidth - LeftOffset	=	.5" - 
LOCAL	dpix	:DWORD
LOCAL	dpiy	:DWORD
LOCAL	var		:DWORD
LOCAL	paper	:POINT 
LOCAL	margin	:RECT  
LOCAL	minmargin	:RECT

;PrintText "Made it to GetPageInfo"
	mov		m_psd.rtMargin.left, 500       ; 1.00 
	mov		m_psd.rtMargin.right, 500      ; 1.00 
	mov		m_psd.rtMargin.top, 500         ; 0.75 
	mov		m_psd.rtMargin.bottom, 500      ; 0.75 

	invoke	GetDeviceCaps, dcPrint, LOGPIXELSX
	mov		dpix, eax
	invoke	GetDeviceCaps, dcPrint, LOGPIXELSY
	mov		dpiy, eax

	invoke	GetDeviceCaps, dcPrint, PHYSICALWIDTH
	invoke	IntMul, eax, 1000
	invoke	IntDiv, eax, dpix   
	mov		m_psd.ptPaperSize.x, eax

	invoke	GetDeviceCaps, dcPrint, PHYSICALHEIGHT
	invoke	IntMul, eax, 1000       
	invoke	IntDiv, eax, dpiy   
	mov		m_psd.ptPaperSize.y, eax
	invoke	GetDeviceCaps, dcPrint, PHYSICALOFFSETX
	invoke	IntMul, eax, 1000
	invoke	IntDiv, eax, dpix   
	mov		m_psd.rtMinMargin.left, eax

	invoke	GetDeviceCaps, dcPrint, PHYSICALOFFSETY
	invoke	IntMul, eax, 1000
	invoke	IntDiv, eax, dpiy   
	mov		m_psd.rtMinMargin.top, eax

	invoke	GetDeviceCaps, dcPrint, HORZRES
	invoke	IntMul, eax, 1000
	invoke	IntDiv, eax, dpix    

	m2m		var, m_psd.ptPaperSize.x    ; m_psd.rtMinMargin.right = ebx - edx - eax
	mov		edx, m_psd.rtMinMargin.left

	sub		var, edx
	sub		var, eax
	m2m		m_psd.rtMinMargin.right, var

	invoke	GetDeviceCaps, dcPrint, VERTRES
	invoke	IntMul, eax, 1000
	invoke	IntDiv, eax, dpiy    

	m2m		var, m_psd.ptPaperSize.y    ; m_psd.rtMinMargin.bottom = ebx - edx - eax
	mov		edx, m_psd.rtMinMargin.top

	sub		var, edx
	sub		var, eax   

	m2m		m_psd.rtMinMargin.bottom, var
    m2m		paper.x, m_psd.ptPaperSize.x    
    m2m		paper.y, m_psd.ptPaperSize.y       

    invoke	CopyRect,ADDR margin,ADDR m_psd.rtMargin
    invoke	CopyRect,ADDR minmargin,ADDR m_psd.rtMinMargin

    mov		eax, paper.x
    invoke	IntMul, eax, BASE_DPI   
    invoke	IntDiv, eax, 1000
    mov		m_Paper.x, eax
    
    mov		eax, paper.y
    invoke	IntMul, eax, BASE_DPI   
    invoke	IntDiv, eax, 1000    
    mov		m_Paper.y, eax
    
    mov		eax, margin.left
    invoke	IntMul, eax, BASE_DPI   
    invoke	IntDiv, eax, 1000    
    mov		m_Margin.left, eax
 
    mov		eax, margin.right
    invoke	IntMul, eax, BASE_DPI   
    invoke	IntDiv, eax, 1000    
    mov		m_Margin.right, eax
    
    mov		eax, margin.top
    invoke	IntMul, eax, BASE_DPI   
    invoke	IntDiv, eax, 1000    
    mov		m_Margin.top, eax
 
    mov		eax, margin.bottom
    invoke	IntMul, eax, BASE_DPI   
    invoke	IntDiv, eax, 1000    
    mov		m_Margin.bottom, eax
	
	ret

GetPageInfo endp

FormatScreenLikePrinter	PROC
;Display the RichEdit content as they will on the printed page
	mov		eax, m_psd.ptPaperSize.x	;Printer.Width
	sub		eax, 500					;RightMarginWidth
	sub		eax, 500					;LeftMarginWidth
	invoke	SendMessage, hREd, EM_SETTARGETDEVICE, dcPrint, eax

	ret

FormatScreenLikePrinter	ENDP

PrintFile	PROC
LOCAL rtf_length:DWORD
LOCAL FR:FORMATRANGE
LOCAL ft:FINDTEXTEX
LOCAL gtl:GETTEXTLENGTHEX
LOCAL DOC:DOCINFO

;Clear EM_FORMATRANGE process
	invoke	SendMessage, hREd, EM_FORMATRANGE, 0, 0

;Setup FR FORMATRANGE structure
	m2m		FR.hdc, dcPrint			;format for the printer
	m2m		FR.hdcTarget, dcPrint

	m2m		FR.rc.left, m_Margin.left

	m2m		FR.rc.top, m_Margin.top

	mov		eax, m_Paper.x
	sub		eax, m_Margin.right
	mov		FR.rc.right, eax

	mov		eax, m_Paper.y
	sub		eax, m_Margin.bottom
	mov		FR.rc.bottom, eax

	mov		FR.rcPage.left, 0
	mov		FR.rcPage.top, 0
	m2m		FR.rcPage.right, m_Paper.x
	m2m		FR.rcPage.bottom, m_Paper.y

;Setup EM_GETTEXTLENGTH structure
	mov		gtl.flags, GTL_PRECISE
	mov		gtl.codepage, CP_ACP
	invoke	SendMessage, hREd, EM_GETTEXTLENGTHEX, addr gtl, 0
	mov		rtf_length, eax

	mov		FR.chrg.cpMin, 0		;Format from beginning of RichEdit content
	mov		FR.chrg.cpMax, -1		;Format to end of content
	mov		ft.chrg.cpMin, 0		;Beginning range of EM_FINDTEXTEX, start at beginning
	m2m		ft.chrg.cpMax, -1		;FINDTEXT to end of content
;Text EM_FINDTEXTEX will search for
	mov		ft.lpstrText, offset j_page_break
;Zero out EM_FINDTEXTEX results
	mov		ft.chrgText.cpMin, 0
	mov		ft.chrgText.cpMax, 0

	mov		DOC.cbSize, SIZEOF DOC
	mov		DOC.lpszDocName, offset DocTitle
	mov		DOC.lpszOutput, NULL
	mov		DOC.lpszDatatype, NULL
	mov		DOC.fwType, NULL


	invoke	StartDoc, dcPrint, addr DOC
	invoke	StartPage, dcPrint
	invoke	SendMessage, hREd, EM_FINDTEXTEX, FR_DOWN, addr ft		;try to find first page break
	.if( eax == -1 )												;no page break found
		mov		FR.chrg.cpMin, 0									;start at beginning of content
		mov		FR.chrg.cpMax, -1									;process to end of content
		invoke	SendMessage, hREd, EM_FORMATRANGE, TRUE, addr FR	;first page
		mov		FR.chrg.cpMin, eax									;prepare for next page
		mov		FR.chrg.cpMax, -1
		.while( eax < rtf_length )									;more pages to process
			invoke	EndPage, dcPrint
			invoke	StartPage, dcPrint
			invoke	SendMessage, hREd, EM_FORMATRANGE, TRUE, addr FR
			mov		FR.chrg.cpMin, eax								;prepare for next page
			mov		FR.chrg.cpMax, -1								;process to end of content
		.endw
		invoke	EndPage, dcPrint
	.else															;process page breaks
		mov		FR.chrg.cpMin, 0									;start at beginning of content
		m2m		FR.chrg.cpMax, ft.chrgText.cpMin					;process to beginning of found text
		invoke	SendMessage, hREd, EM_FORMATRANGE, TRUE, addr FR	;process first page
		.while( eax < rtf_length )									;more content to process
;Excessive Content of first page may cause page break to fall over to following page
			.while( eax < FR.chrg.cpMax )				;page break not on previous EM_FORMATed page
				mov		FR.chrg.cpMin, eax				;start next page right after last page
				m2m		FR.chrg.cpMax, ft.chrgText.cpMin		;process to beginning of found text
				invoke	EndPage, dcPrint
				invoke	StartPage, dcPrint
				invoke	SendMessage, hREd, EM_FORMATRANGE, TRUE, addr FR
;Print content until we reach the next page break
			.endw
			invoke	EndPage, dcPrint
			invoke	StartPage, dcPrint
;Print content after page break, first check if there is another  page break, if not format the rest
			m2m	FR.chrg.cpMin, ft.chrgText.cpMax		;start next page after last char of found text
			m2m	ft.chrg.cpMin, ft.chrgText.cpMax		;start next search after last char of found text
			mov ft.chrg.cpMax, -1						;search to end of content
			mov	ft.chrgText.cpMin, 0
			mov	ft.chrgText.cpMax, 0
			invoke	SendMessage, hREd, EM_FINDTEXTEX, FR_DOWN, addr ft		;try to find page break
			.if( eax == -1 )							;no more page breaks
				m2m	FR.chrg.cpMax, -1
				mov	eax, FR.chrg.cpMin
				.while( eax < rtf_length )									;more pages to process
					invoke	SendMessage, hREd, EM_FORMATRANGE, TRUE, addr FR
					mov		FR.chrg.cpMin, eax								;prepare for next page
					mov		FR.chrg.cpMax, -1								;process to end of content
				.endw
			.else									;prepare for next page break
				m2m		FR.chrg.cpMax, ft.chrgText.cpMin					;process to beginning of found text
				invoke	SendMessage, hREd, EM_FORMATRANGE, TRUE, addr FR
			.endif
		.endw
		invoke	EndPage, dcPrint
	.endif
	
	invoke	EndDoc, dcPrint
	invoke	SendMessage, hREd, EM_FORMATRANGE, 0, 0
	invoke	DeleteDC, dcPrint
		
;ClosePrinter
	push	hPrinter
	call	pClosePrinter
	invoke	GlobalUnlock, pDevmodeOut
	invoke	GlobalFree, hDevmodeOut

	ret

PrintFile endp

UnChangeBP	PROC uses edi esi
LOCAL	hFile, rtf_length, tempH, tempP, NumRtfBytes:DWORD
	invoke	CreateFile, addr Masm32RTF, \
			GENERIC_READ + GENERIC_WRITE, FILE_SHARE_READ, NULL,\
			OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL
	mov		hFile, eax
	invoke	GetFileSize, hFile, NULL
	mov		rtf_length, eax
	invoke	GlobalAlloc, GMEM_MOVEABLE, eax
	mov		tempH, eax
	invoke	GlobalLock, eax
	mov		tempP, eax
	invoke	ReadFile, hFile, tempP, rtf_length, addr NumRtfBytes, 0
	mov		ecx, NumRtfBytes
	mov		edi, tempP
	mov		esi, 0
	mov		eax, 'gap*'
FindBS:
	cmp		dword ptr [edi], eax
	je		got_pb
check_a:
	inc		edi
	inc		esi
	dec		ecx
	je		got_pb
	jmp		FindBS
got_pb:
	.if( ecx )				;not done processing for page breaks
		mov	byte ptr [edi], '\'
		add	edi, 5
		add esi, 5
		sub	ecx, 5
		je	done_pb
		jmp	FindBS
	.endif
done_pb:
	invoke	SetFilePointer, hFile, 0, 0, FILE_BEGIN
	invoke	WriteFile, hFile, tempP, NumRtfBytes, addr NumRtfBytes, 0
	invoke	CloseHandle, hFile
	invoke	GlobalUnlock, tempP
	invoke	GlobalFree, tempH

	ret

UnChangeBP endp

end start
